/*##############################################################################

    HPCC SYSTEMS software Copyright (C) 2012 HPCC Systems.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
############################################################################## */

// IMPORTANT: this test is generated by the perl script genjointest.pl, so do not edit it by hand
//nothor
//nothorlcr
//nohthor

#option('convertJoinToLookup', 0);
#option('noAllToLookupConversion', 1);
#option('spanMultipleCpp', 1);

jrec := RECORD,MAXLENGTH(100)
    UNSIGNED1 i;
    STRING3 lstr;
    STRING3 rstr;
    UNSIGNED1 c;
    STRING label;
END;

lhs := SORTED(DATASET([{3, 'aaa', '', 0, ''}, {4, 'bbb', '', 0, ''}, {5, 'ccc', '', 0, ''}, {6, 'ddd', '', 0, ''}, {7, 'eee', '', 0, ''}], jrec), i);
rhs := SORTED(DATASET([{1, '', 'fff', 0, ''}, {3, '', 'ggg', 0, ''}, {5, '', 'hhh', 0, ''}, {5, '', 'iii', 0, ''}, {5, '', 'xxx', 0, ''}, {5, '', 'jjj', 0, ''}, {7, '', 'kkk', 0, ''}, {9, '', 'lll', 0, ''}, {9, '', 'mmm', 0, ''}], jrec), i);

trueval := true : stored('trueval');
falseval := false : stored('falseval');
BOOLEAN match1(jrec l, jrec r) := (l.i = r.i);
BOOLEAN match2(jrec l, jrec r) := (r.rstr < 'x');
BOOLEAN match(jrec l, jrec r) := (match1(l, r) AND match2(l, r));
BOOLEAN allmatch1(jrec l, jrec r) := ((match1(l, r) AND trueval) OR falseval);
BOOLEAN allmatch(jrec l, jrec r) := (allmatch1(l, r) AND match2(l, r));

// transform for joins and non-group denormalizes, to be used with match or allmatch
jrec xfm(jrec l, jrec r, STRING lab) := TRANSFORM
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := r.rstr;
    SELF.c := l.c+1;
    SELF.label := lab;
END;

// skipping transform for joins and non-group denormalizes
// when used with match1 or allmatch1, similar to the above, but remember that right outer picks up rows whose matches failed but not ones whose transforms skipped
jrec xfmskip(jrec l, jrec r, STRING lab) := TRANSFORM
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := IF(r.rstr >= 'x', SKIP, r.rstr);
    SELF.c := l.c+1;
    SELF.label := lab;
END;

// transform for group denormalizes, to be used with match or allmatch
jrec xfmgrp(jrec l, DATASET(jrec) r, STRING lab) := TRANSFORM
    UNSIGNED c := COUNT(r);
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := r[c].rstr;
    SELF.c := c;
    SELF.label := lab;
END;

// skipping transform for group denormalizes, to be used with match or allmatch
// used with match1 or allmatch1, but has a different behaviour because a skip on a group denormalize skips the whole group rather than just one row
jrec xfmgrpskip(jrec l, DATASET(jrec) r, STRING lab) := TRANSFORM
    UNSIGNED c := COUNT(r);
    UNSIGNED skp := COUNT(r(rstr >= 'x'));
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := IF(skp > 0, SKIP, r[c].rstr);
    SELF.c := c;
    SELF.label := lab;
END;

join____INN_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_PAR'), INNER, PARALLEL);
join____INN____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_XFMSKIP_PAR'), INNER, PARALLEL);
join____INN_kp____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_KEEP_PAR'), INNER, KEEP(2), PARALLEL);
join____INN_kp_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_KEEP_XFMSKIP_PAR'), INNER, KEEP(2), PARALLEL);
join____INN_at____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_ATMOST_PAR'), INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join____INN_at_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_ATMOST_XFMSKIP_PAR'), INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join____INN_ls____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LIMITSKIP_PAR'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LIMITSKIP_PAR')), PARALLEL);
join____INN_ls_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LIMITSKIP_XFMSKIP_PAR'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
join____INN_lo____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LIMITONFAIL_PAR'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LIMITONFAIL_PAR')), PARALLEL);
join____INN_lo_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LIMITONFAIL_XFMSKIP_PAR'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
join____INN_lf____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LIMITFAIL_PAR'), INNER, LIMIT(3), PARALLEL);
join____INN_lf_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LIMITFAIL_XFMSKIP_PAR'), INNER, LIMIT(3), PARALLEL);
join____LOU_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_OUTER_PAR'), LEFT OUTER, PARALLEL);
join____LOU____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_OUTER_XFMSKIP_PAR'), LEFT OUTER, PARALLEL);
join____LOU_kp____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_OUTER_KEEP_PAR'), LEFT OUTER, KEEP(2), PARALLEL);
join____LOU_kp_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_OUTER_KEEP_XFMSKIP_PAR'), LEFT OUTER, KEEP(2), PARALLEL);
join____LOU_at____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_OUTER_ATMOST_PAR'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join____LOU_at_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_OUTER_ATMOST_XFMSKIP_PAR'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join____LOU_ls____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_OUTER_LIMITSKIP_PAR'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LEFT_OUTER_LIMITSKIP_PAR')), PARALLEL);
join____LOU_ls_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
join____LOU_lo____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_OUTER_LIMITONFAIL_PAR'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LEFT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
join____LOU_lo_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
join____LOU_lf____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_OUTER_LIMITFAIL_PAR'), LEFT OUTER, LIMIT(3), PARALLEL);
join____LOU_lf_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_OUTER_LIMITFAIL_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3), PARALLEL);
join____LON_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_ONLY_PAR'), LEFT ONLY, PARALLEL);
join____LON____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_ONLY_XFMSKIP_PAR'), LEFT ONLY, PARALLEL);
join____LON_at____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LEFT_ONLY_ATMOST_PAR'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join____LON_at_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LEFT_ONLY_ATMOST_XFMSKIP_PAR'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join____ROU_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_PAR'), RIGHT OUTER, PARALLEL);
join____ROU____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_XFMSKIP_PAR'), RIGHT OUTER, PARALLEL);
join____ROU_ls____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_LIMITSKIP_PAR'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_RIGHT_OUTER_LIMITSKIP_PAR')), PARALLEL);
join____ROU_ls_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
join____ROU_lo____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_LIMITONFAIL_PAR'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_RIGHT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
join____ROU_lo_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
join____ROU_lf____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_LIMITFAIL_PAR'), RIGHT OUTER, LIMIT(3), PARALLEL);
join____ROU_lf_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_RIGHT_OUTER_LIMITFAIL_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3), PARALLEL);
join____RON_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_RIGHT_ONLY_PAR'), RIGHT ONLY, PARALLEL);
join____RON____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_RIGHT_ONLY_XFMSKIP_PAR'), RIGHT ONLY, PARALLEL);
join____FOU_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_FULL_OUTER_PAR'), FULL OUTER, PARALLEL);
join____FOU____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_FULL_OUTER_XFMSKIP_PAR'), FULL OUTER, PARALLEL);
join____FOU_ls____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_FULL_OUTER_LIMITSKIP_PAR'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_FULL_OUTER_LIMITSKIP_PAR')), PARALLEL);
join____FOU_ls_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
join____FOU_lo____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_FULL_OUTER_LIMITONFAIL_PAR'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_FULL_OUTER_LIMITONFAIL_PAR')), PARALLEL);
join____FOU_lo_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
join____FOU_lf____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_FULL_OUTER_LIMITFAIL_PAR'), FULL OUTER, LIMIT(3), PARALLEL);
join____FOU_lf_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_FULL_OUTER_LIMITFAIL_XFMSKIP_PAR'), FULL OUTER, LIMIT(3), PARALLEL);
join____FON_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_FULL_ONLY_PAR'), FULL ONLY, PARALLEL);
join____FON____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_FULL_ONLY_XFMSKIP_PAR'), FULL ONLY, PARALLEL);
join_l1_INN_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_PAR'), LOOKUP, INNER, PARALLEL);
join_l1_INN____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_XFMSKIP_PAR'), LOOKUP, INNER, PARALLEL);
join_l1_LOU_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_LEFT_OUTER_PAR'), LOOKUP, LEFT OUTER, PARALLEL);
join_l1_LOU____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_LEFT_OUTER_XFMSKIP_PAR'), LOOKUP, LEFT OUTER, PARALLEL);
join_l1_LON_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_LEFT_ONLY_PAR'), LOOKUP, LEFT ONLY, PARALLEL);
join_l1_LON____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_LEFT_ONLY_XFMSKIP_PAR'), LOOKUP, LEFT ONLY, PARALLEL);
join_lm_INN_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_PAR'), LOOKUP, MANY, INNER, PARALLEL);
join_lm_INN____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_XFMSKIP_PAR'), LOOKUP, MANY, INNER, PARALLEL);
join_lm_INN_kp____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_KEEP_PAR'), LOOKUP, MANY, INNER, KEEP(2), PARALLEL);
join_lm_INN_kp_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_KEEP_XFMSKIP_PAR'), LOOKUP, MANY, INNER, KEEP(2), PARALLEL);
join_lm_INN_at____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_ATMOST_PAR'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join_lm_INN_at_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join_lm_INN_ls____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LIMITSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LIMITSKIP_PAR')), PARALLEL);
join_lm_INN_ls_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
join_lm_INN_lo____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LIMITONFAIL_PAR'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LIMITONFAIL_PAR')), PARALLEL);
join_lm_INN_lo_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
join_lm_INN_lf____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LIMITFAIL_PAR'), LOOKUP, MANY, INNER, LIMIT(3), PARALLEL);
join_lm_INN_lf_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LIMITFAIL_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3), PARALLEL);
join_lm_LOU_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_PAR'), LOOKUP, MANY, LEFT OUTER, PARALLEL);
join_lm_LOU____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, PARALLEL);
join_lm_LOU_kp____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_KEEP_PAR'), LOOKUP, MANY, LEFT OUTER, KEEP(2), PARALLEL);
join_lm_LOU_kp_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, KEEP(2), PARALLEL);
join_lm_LOU_at____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_ATMOST_PAR'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join_lm_LOU_at_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join_lm_LOU_ls____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR')), PARALLEL);
join_lm_LOU_ls_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
join_lm_LOU_lo____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
join_lm_LOU_lo_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
join_lm_LOU_lf____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), PARALLEL);
join_lm_LOU_lf_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), PARALLEL);
join_lm_LON_______p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_ONLY_PAR'), LOOKUP, MANY, LEFT ONLY, PARALLEL);
join_lm_LON____xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_ONLY_XFMSKIP_PAR'), LOOKUP, MANY, LEFT ONLY, PARALLEL);
join_lm_LON_at____p := JOIN(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_ONLY_ATMOST_PAR'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join_lm_LON_at_xs_p := JOIN(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
join_al_INN_______p := JOIN(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_ALL_PAR'), ALL, INNER, PARALLEL);
join_al_INN____xs_p := JOIN(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_ALL_XFMSKIP_PAR'), ALL, INNER, PARALLEL);
join_al_INN_kp____p := JOIN(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_ALL_KEEP_PAR'), ALL, INNER, KEEP(2), PARALLEL);
join_al_INN_kp_xs_p := JOIN(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_ALL_KEEP_XFMSKIP_PAR'), ALL, INNER, KEEP(2), PARALLEL);
join_al_LOU_______p := JOIN(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_ALL_LEFT_OUTER_PAR'), ALL, LEFT OUTER, PARALLEL);
join_al_LOU____xs_p := JOIN(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_ALL_LEFT_OUTER_XFMSKIP_PAR'), ALL, LEFT OUTER, PARALLEL);
join_al_LOU_kp____p := JOIN(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_ALL_LEFT_OUTER_KEEP_PAR'), ALL, LEFT OUTER, KEEP(2), PARALLEL);
join_al_LOU_kp_xs_p := JOIN(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_ALL_LEFT_OUTER_KEEP_XFMSKIP_PAR'), ALL, LEFT OUTER, KEEP(2), PARALLEL);
join_al_LON_______p := JOIN(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'JOIN_ALL_LEFT_ONLY_PAR'), ALL, LEFT ONLY, PARALLEL);
join_al_LON____xs_p := JOIN(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'JOIN_ALL_LEFT_ONLY_XFMSKIP_PAR'), ALL, LEFT ONLY, PARALLEL);
deno____INN_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_PAR'), INNER, PARALLEL);
deno____INN____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_XFMSKIP_PAR'), INNER, PARALLEL);
deno____INN_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_KEEP_PAR'), INNER, KEEP(2), PARALLEL);
deno____INN_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_KEEP_XFMSKIP_PAR'), INNER, KEEP(2), PARALLEL);
deno____INN_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ATMOST_PAR'), INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno____INN_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ATMOST_XFMSKIP_PAR'), INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno____INN_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LIMITSKIP_PAR'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITSKIP_PAR')), PARALLEL);
deno____INN_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LIMITSKIP_XFMSKIP_PAR'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
deno____INN_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LIMITONFAIL_PAR'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITONFAIL_PAR')), PARALLEL);
deno____INN_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LIMITONFAIL_XFMSKIP_PAR'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
deno____INN_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LIMITFAIL_PAR'), INNER, LIMIT(3), PARALLEL);
deno____INN_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LIMITFAIL_XFMSKIP_PAR'), INNER, LIMIT(3), PARALLEL);
deno____LOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_PAR'), LEFT OUTER, PARALLEL);
deno____LOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_XFMSKIP_PAR'), LEFT OUTER, PARALLEL);
deno____LOU_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_KEEP_PAR'), LEFT OUTER, KEEP(2), PARALLEL);
deno____LOU_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_KEEP_XFMSKIP_PAR'), LEFT OUTER, KEEP(2), PARALLEL);
deno____LOU_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_ATMOST_PAR'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno____LOU_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_ATMOST_XFMSKIP_PAR'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno____LOU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITSKIP_PAR'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITSKIP_PAR')), PARALLEL);
deno____LOU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
deno____LOU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITONFAIL_PAR'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
deno____LOU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
deno____LOU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITFAIL_PAR'), LEFT OUTER, LIMIT(3), PARALLEL);
deno____LOU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITFAIL_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3), PARALLEL);
deno____LON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_PAR'), LEFT ONLY, PARALLEL);
deno____LON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_XFMSKIP_PAR'), LEFT ONLY, PARALLEL);
deno____LON_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_ATMOST_PAR'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno____LON_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_ATMOST_XFMSKIP_PAR'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno____ROU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_PAR'), RIGHT OUTER, PARALLEL);
deno____ROU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_XFMSKIP_PAR'), RIGHT OUTER, PARALLEL);
deno____ROU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITSKIP_PAR'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITSKIP_PAR')), PARALLEL);
deno____ROU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
deno____ROU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_PAR'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
deno____ROU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
deno____ROU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITFAIL_PAR'), RIGHT OUTER, LIMIT(3), PARALLEL);
deno____ROU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITFAIL_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3), PARALLEL);
deno____RON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_ONLY_PAR'), RIGHT ONLY, PARALLEL);
deno____RON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_ONLY_XFMSKIP_PAR'), RIGHT ONLY, PARALLEL);
deno____FOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_PAR'), FULL OUTER, PARALLEL);
deno____FOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_XFMSKIP_PAR'), FULL OUTER, PARALLEL);
deno____FOU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITSKIP_PAR'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITSKIP_PAR')), PARALLEL);
deno____FOU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
deno____FOU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITONFAIL_PAR'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITONFAIL_PAR')), PARALLEL);
deno____FOU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
deno____FOU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITFAIL_PAR'), FULL OUTER, LIMIT(3), PARALLEL);
deno____FOU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITFAIL_XFMSKIP_PAR'), FULL OUTER, LIMIT(3), PARALLEL);
deno____FON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_ONLY_PAR'), FULL ONLY, PARALLEL);
deno____FON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_ONLY_XFMSKIP_PAR'), FULL ONLY, PARALLEL);
deno_l1_INN_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_PAR'), LOOKUP, INNER, PARALLEL);
deno_l1_INN____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_XFMSKIP_PAR'), LOOKUP, INNER, PARALLEL);
deno_l1_LOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_OUTER_PAR'), LOOKUP, LEFT OUTER, PARALLEL);
deno_l1_LOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_OUTER_XFMSKIP_PAR'), LOOKUP, LEFT OUTER, PARALLEL);
deno_l1_LON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_ONLY_PAR'), LOOKUP, LEFT ONLY, PARALLEL);
deno_l1_LON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_ONLY_XFMSKIP_PAR'), LOOKUP, LEFT ONLY, PARALLEL);
deno_lm_INN_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_PAR'), LOOKUP, MANY, INNER, PARALLEL);
deno_lm_INN____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_XFMSKIP_PAR'), LOOKUP, MANY, INNER, PARALLEL);
deno_lm_INN_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_KEEP_PAR'), LOOKUP, MANY, INNER, KEEP(2), PARALLEL);
deno_lm_INN_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_KEEP_XFMSKIP_PAR'), LOOKUP, MANY, INNER, KEEP(2), PARALLEL);
deno_lm_INN_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_ATMOST_PAR'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno_lm_INN_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno_lm_INN_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITSKIP_PAR')), PARALLEL);
deno_lm_INN_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
deno_lm_INN_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_PAR'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_PAR')), PARALLEL);
deno_lm_INN_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
deno_lm_INN_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITFAIL_PAR'), LOOKUP, MANY, INNER, LIMIT(3), PARALLEL);
deno_lm_INN_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITFAIL_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3), PARALLEL);
deno_lm_LOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_PAR'), LOOKUP, MANY, LEFT OUTER, PARALLEL);
deno_lm_LOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, PARALLEL);
deno_lm_LOU_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP_PAR'), LOOKUP, MANY, LEFT OUTER, KEEP(2), PARALLEL);
deno_lm_LOU_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, KEEP(2), PARALLEL);
deno_lm_LOU_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST_PAR'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno_lm_LOU_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno_lm_LOU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR')), PARALLEL);
deno_lm_LOU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
deno_lm_LOU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
deno_lm_LOU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
deno_lm_LOU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), PARALLEL);
deno_lm_LOU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), PARALLEL);
deno_lm_LON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_PAR'), LOOKUP, MANY, LEFT ONLY, PARALLEL);
deno_lm_LON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_XFMSKIP_PAR'), LOOKUP, MANY, LEFT ONLY, PARALLEL);
deno_lm_LON_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST_PAR'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno_lm_LON_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
deno_al_INN_______p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_PAR'), ALL, INNER, PARALLEL);
deno_al_INN____xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_XFMSKIP_PAR'), ALL, INNER, PARALLEL);
deno_al_INN_kp____p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_KEEP_PAR'), ALL, INNER, KEEP(2), PARALLEL);
deno_al_INN_kp_xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_KEEP_XFMSKIP_PAR'), ALL, INNER, KEEP(2), PARALLEL);
deno_al_LOU_______p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_PAR'), ALL, LEFT OUTER, PARALLEL);
deno_al_LOU____xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_XFMSKIP_PAR'), ALL, LEFT OUTER, PARALLEL);
deno_al_LOU_kp____p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_KEEP_PAR'), ALL, LEFT OUTER, KEEP(2), PARALLEL);
deno_al_LOU_kp_xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_KEEP_XFMSKIP_PAR'), ALL, LEFT OUTER, KEEP(2), PARALLEL);
deno_al_LON_______p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_ONLY_PAR'), ALL, LEFT ONLY, PARALLEL);
deno_al_LON____xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_ONLY_XFMSKIP_PAR'), ALL, LEFT ONLY, PARALLEL);
dngr____INN_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_PAR'), INNER, PARALLEL);
dngr____INN____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_XFMSKIP_PAR'), INNER, PARALLEL);
dngr____INN_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_KEEP_PAR'), INNER, KEEP(2), PARALLEL);
dngr____INN_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_KEEP_XFMSKIP_PAR'), INNER, KEEP(2), PARALLEL);
dngr____INN_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ATMOST_PAR'), INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr____INN_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ATMOST_XFMSKIP_PAR'), INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr____INN_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITSKIP_PAR'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITSKIP_PAR')), PARALLEL);
dngr____INN_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITSKIP_XFMSKIP_PAR'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
dngr____INN_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITONFAIL_PAR'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITONFAIL_PAR')), PARALLEL);
dngr____INN_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITONFAIL_XFMSKIP_PAR'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
dngr____INN_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITFAIL_PAR'), INNER, LIMIT(3), PARALLEL);
dngr____INN_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITFAIL_XFMSKIP_PAR'), INNER, LIMIT(3), PARALLEL);
dngr____LOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_PAR'), LEFT OUTER, PARALLEL);
dngr____LOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_XFMSKIP_PAR'), LEFT OUTER, PARALLEL);
dngr____LOU_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_KEEP_PAR'), LEFT OUTER, KEEP(2), PARALLEL);
dngr____LOU_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_KEEP_XFMSKIP_PAR'), LEFT OUTER, KEEP(2), PARALLEL);
dngr____LOU_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_ATMOST_PAR'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr____LOU_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_ATMOST_XFMSKIP_PAR'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr____LOU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_PAR'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_PAR')), PARALLEL);
dngr____LOU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
dngr____LOU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_PAR'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
dngr____LOU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
dngr____LOU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITFAIL_PAR'), LEFT OUTER, LIMIT(3), PARALLEL);
dngr____LOU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITFAIL_XFMSKIP_PAR'), LEFT OUTER, LIMIT(3), PARALLEL);
dngr____LON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_PAR'), LEFT ONLY, PARALLEL);
dngr____LON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_XFMSKIP_PAR'), LEFT ONLY, PARALLEL);
dngr____LON_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_ATMOST_PAR'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr____LON_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_ATMOST_XFMSKIP_PAR'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr____ROU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_PAR'), RIGHT OUTER, PARALLEL);
dngr____ROU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_XFMSKIP_PAR'), RIGHT OUTER, PARALLEL);
dngr____ROU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_PAR'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_PAR')), PARALLEL);
dngr____ROU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
dngr____ROU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_PAR'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
dngr____ROU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
dngr____ROU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITFAIL_PAR'), RIGHT OUTER, LIMIT(3), PARALLEL);
dngr____ROU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITFAIL_XFMSKIP_PAR'), RIGHT OUTER, LIMIT(3), PARALLEL);
dngr____RON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_ONLY_PAR'), RIGHT ONLY, PARALLEL);
dngr____RON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_ONLY_XFMSKIP_PAR'), RIGHT ONLY, PARALLEL);
dngr____FOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_PAR'), FULL OUTER, PARALLEL);
dngr____FOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_XFMSKIP_PAR'), FULL OUTER, PARALLEL);
dngr____FOU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_PAR'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_PAR')), PARALLEL);
dngr____FOU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
dngr____FOU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_PAR'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_PAR')), PARALLEL);
dngr____FOU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
dngr____FOU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITFAIL_PAR'), FULL OUTER, LIMIT(3), PARALLEL);
dngr____FOU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITFAIL_XFMSKIP_PAR'), FULL OUTER, LIMIT(3), PARALLEL);
dngr____FON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_ONLY_PAR'), FULL ONLY, PARALLEL);
dngr____FON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_ONLY_XFMSKIP_PAR'), FULL ONLY, PARALLEL);
dngr_l1_INN_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_PAR'), LOOKUP, INNER, PARALLEL);
dngr_l1_INN____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_XFMSKIP_PAR'), LOOKUP, INNER, PARALLEL);
dngr_l1_LOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_OUTER_PAR'), LOOKUP, LEFT OUTER, PARALLEL);
dngr_l1_LOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_OUTER_XFMSKIP_PAR'), LOOKUP, LEFT OUTER, PARALLEL);
dngr_l1_LON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_ONLY_PAR'), LOOKUP, LEFT ONLY, PARALLEL);
dngr_l1_LON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_ONLY_XFMSKIP_PAR'), LOOKUP, LEFT ONLY, PARALLEL);
dngr_lm_INN_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_PAR'), LOOKUP, MANY, INNER, PARALLEL);
dngr_lm_INN____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_XFMSKIP_PAR'), LOOKUP, MANY, INNER, PARALLEL);
dngr_lm_INN_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_KEEP_PAR'), LOOKUP, MANY, INNER, KEEP(2), PARALLEL);
dngr_lm_INN_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_KEEP_XFMSKIP_PAR'), LOOKUP, MANY, INNER, KEEP(2), PARALLEL);
dngr_lm_INN_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_ATMOST_PAR'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr_lm_INN_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr_lm_INN_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_PAR')), PARALLEL);
dngr_lm_INN_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
dngr_lm_INN_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_PAR'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_PAR')), PARALLEL);
dngr_lm_INN_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
dngr_lm_INN_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITFAIL_PAR'), LOOKUP, MANY, INNER, LIMIT(3), PARALLEL);
dngr_lm_INN_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITFAIL_XFMSKIP_PAR'), LOOKUP, MANY, INNER, LIMIT(3), PARALLEL);
dngr_lm_LOU_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_PAR'), LOOKUP, MANY, LEFT OUTER, PARALLEL);
dngr_lm_LOU____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, PARALLEL);
dngr_lm_LOU_kp____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP_PAR'), LOOKUP, MANY, LEFT OUTER, KEEP(2), PARALLEL);
dngr_lm_LOU_kp_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, KEEP(2), PARALLEL);
dngr_lm_LOU_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST_PAR'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr_lm_LOU_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr_lm_LOU_ls____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR')), PARALLEL);
dngr_lm_LOU_ls_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')), PARALLEL);
dngr_lm_LOU_lo____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR')), PARALLEL);
dngr_lm_LOU_lo_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')), PARALLEL);
dngr_lm_LOU_lf____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), PARALLEL);
dngr_lm_LOU_lf_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_XFMSKIP_PAR'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), PARALLEL);
dngr_lm_LON_______p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_PAR'), LOOKUP, MANY, LEFT ONLY, PARALLEL);
dngr_lm_LON____xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_XFMSKIP_PAR'), LOOKUP, MANY, LEFT ONLY, PARALLEL);
dngr_lm_LON_at____p := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST_PAR'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr_lm_LON_at_xs_p := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP_PAR'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3), PARALLEL);
dngr_al_INN_______p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_PAR'), ALL, INNER, PARALLEL);
dngr_al_INN____xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_XFMSKIP_PAR'), ALL, INNER, PARALLEL);
dngr_al_INN_kp____p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_KEEP_PAR'), ALL, INNER, KEEP(2), PARALLEL);
dngr_al_INN_kp_xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_KEEP_XFMSKIP_PAR'), ALL, INNER, KEEP(2), PARALLEL);
dngr_al_LOU_______p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_PAR'), ALL, LEFT OUTER, PARALLEL);
dngr_al_LOU____xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_XFMSKIP_PAR'), ALL, LEFT OUTER, PARALLEL);
dngr_al_LOU_kp____p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP_PAR'), ALL, LEFT OUTER, KEEP(2), PARALLEL);
dngr_al_LOU_kp_xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP_XFMSKIP_PAR'), ALL, LEFT OUTER, KEEP(2), PARALLEL);
dngr_al_LON_______p := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_ONLY_PAR'), ALL, LEFT ONLY, PARALLEL);
dngr_al_LON____xs_p := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_ONLY_XFMSKIP_PAR'), ALL, LEFT ONLY, PARALLEL);

SEQUENTIAL(OUTPUT(join____INN_______p, NAMED('JOIN_PAR')),
           OUTPUT(join____INN____xs_p, NAMED('JOIN_XFMSKIP_PAR')),
           OUTPUT(join____INN_kp____p, NAMED('JOIN_KEEP_PAR')),
           OUTPUT(join____INN_kp_xs_p, NAMED('JOIN_KEEP_XFMSKIP_PAR')),
           OUTPUT(join____INN_at____p, NAMED('JOIN_ATMOST_PAR')),
           OUTPUT(join____INN_at_xs_p, NAMED('JOIN_ATMOST_XFMSKIP_PAR')),
           OUTPUT(join____INN_ls____p, NAMED('JOIN_LIMITSKIP_PAR')),
           OUTPUT(join____INN_ls_xs_p, NAMED('JOIN_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(join____INN_lo____p, NAMED('JOIN_LIMITONFAIL_PAR')),
           OUTPUT(join____INN_lo_xs_p, NAMED('JOIN_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(join____LOU_______p, NAMED('JOIN_LEFT_OUTER_PAR')),
           OUTPUT(join____LOU____xs_p, NAMED('JOIN_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(join____LOU_kp____p, NAMED('JOIN_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(join____LOU_kp_xs_p, NAMED('JOIN_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(join____LOU_at____p, NAMED('JOIN_LEFT_OUTER_ATMOST_PAR')),
           OUTPUT(join____LOU_at_xs_p, NAMED('JOIN_LEFT_OUTER_ATMOST_XFMSKIP_PAR')),
           OUTPUT(join____LOU_ls____p, NAMED('JOIN_LEFT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(join____LOU_ls_xs_p, NAMED('JOIN_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(join____LOU_lo____p, NAMED('JOIN_LEFT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(join____LOU_lo_xs_p, NAMED('JOIN_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(join____LON_______p, NAMED('JOIN_LEFT_ONLY_PAR')),
           OUTPUT(join____LON____xs_p, NAMED('JOIN_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(join____LON_at____p, NAMED('JOIN_LEFT_ONLY_ATMOST_PAR')),
           OUTPUT(join____LON_at_xs_p, NAMED('JOIN_LEFT_ONLY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(join____ROU_______p, NAMED('JOIN_RIGHT_OUTER_PAR')),
           OUTPUT(join____ROU____xs_p, NAMED('JOIN_RIGHT_OUTER_XFMSKIP_PAR')),
           OUTPUT(join____ROU_ls____p, NAMED('JOIN_RIGHT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(join____ROU_ls_xs_p, NAMED('JOIN_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(join____ROU_lo____p, NAMED('JOIN_RIGHT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(join____ROU_lo_xs_p, NAMED('JOIN_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(join____RON_______p, NAMED('JOIN_RIGHT_ONLY_PAR')),
           OUTPUT(join____RON____xs_p, NAMED('JOIN_RIGHT_ONLY_XFMSKIP_PAR')),
           OUTPUT(join____FOU_______p, NAMED('JOIN_FULL_OUTER_PAR')),
           OUTPUT(join____FOU____xs_p, NAMED('JOIN_FULL_OUTER_XFMSKIP_PAR')),
           OUTPUT(join____FOU_ls____p, NAMED('JOIN_FULL_OUTER_LIMITSKIP_PAR')),
           OUTPUT(join____FOU_ls_xs_p, NAMED('JOIN_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(join____FOU_lo____p, NAMED('JOIN_FULL_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(join____FOU_lo_xs_p, NAMED('JOIN_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(join____FON_______p, NAMED('JOIN_FULL_ONLY_PAR')),
           OUTPUT(join____FON____xs_p, NAMED('JOIN_FULL_ONLY_XFMSKIP_PAR')),
           OUTPUT(join_l1_INN_______p, NAMED('JOIN_LOOKUP_PAR')),
           OUTPUT(join_l1_INN____xs_p, NAMED('JOIN_LOOKUP_XFMSKIP_PAR')),
           OUTPUT(join_l1_LOU_______p, NAMED('JOIN_LOOKUP_LEFT_OUTER_PAR')),
           OUTPUT(join_l1_LOU____xs_p, NAMED('JOIN_LOOKUP_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(join_l1_LON_______p, NAMED('JOIN_LOOKUP_LEFT_ONLY_PAR')),
           OUTPUT(join_l1_LON____xs_p, NAMED('JOIN_LOOKUP_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(join_lm_INN_______p, NAMED('JOIN_LOOKUP_MANY_PAR')),
           OUTPUT(join_lm_INN____xs_p, NAMED('JOIN_LOOKUP_MANY_XFMSKIP_PAR')),
           OUTPUT(join_lm_INN_kp____p, NAMED('JOIN_LOOKUP_MANY_KEEP_PAR')),
           OUTPUT(join_lm_INN_kp_xs_p, NAMED('JOIN_LOOKUP_MANY_KEEP_XFMSKIP_PAR')),
           OUTPUT(join_lm_INN_at____p, NAMED('JOIN_LOOKUP_MANY_ATMOST_PAR')),
           OUTPUT(join_lm_INN_at_xs_p, NAMED('JOIN_LOOKUP_MANY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(join_lm_INN_ls____p, NAMED('JOIN_LOOKUP_MANY_LIMITSKIP_PAR')),
           OUTPUT(join_lm_INN_ls_xs_p, NAMED('JOIN_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(join_lm_INN_lo____p, NAMED('JOIN_LOOKUP_MANY_LIMITONFAIL_PAR')),
           OUTPUT(join_lm_INN_lo_xs_p, NAMED('JOIN_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(join_lm_LOU_______p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_PAR')),
           OUTPUT(join_lm_LOU____xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(join_lm_LOU_kp____p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(join_lm_LOU_kp_xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(join_lm_LOU_at____p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_ATMOST_PAR')),
           OUTPUT(join_lm_LOU_at_xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP_PAR')),
           OUTPUT(join_lm_LOU_ls____p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(join_lm_LOU_ls_xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(join_lm_LOU_lo____p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(join_lm_LOU_lo_xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(join_lm_LON_______p, NAMED('JOIN_LOOKUP_MANY_LEFT_ONLY_PAR')),
           OUTPUT(join_lm_LON____xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(join_lm_LON_at____p, NAMED('JOIN_LOOKUP_MANY_LEFT_ONLY_ATMOST_PAR')),
           OUTPUT(join_lm_LON_at_xs_p, NAMED('JOIN_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(join_al_INN_______p, NAMED('JOIN_ALL_PAR')),
           OUTPUT(join_al_INN____xs_p, NAMED('JOIN_ALL_XFMSKIP_PAR')),
           OUTPUT(join_al_INN_kp____p, NAMED('JOIN_ALL_KEEP_PAR')),
           OUTPUT(join_al_INN_kp_xs_p, NAMED('JOIN_ALL_KEEP_XFMSKIP_PAR')),
           OUTPUT(join_al_LOU_______p, NAMED('JOIN_ALL_LEFT_OUTER_PAR')),
           OUTPUT(join_al_LOU____xs_p, NAMED('JOIN_ALL_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(join_al_LOU_kp____p, NAMED('JOIN_ALL_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(join_al_LOU_kp_xs_p, NAMED('JOIN_ALL_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(join_al_LON_______p, NAMED('JOIN_ALL_LEFT_ONLY_PAR')),
           OUTPUT(join_al_LON____xs_p, NAMED('JOIN_ALL_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(deno____INN_______p, NAMED('DENORMALIZE_PAR')),
           OUTPUT(deno____INN____xs_p, NAMED('DENORMALIZE_XFMSKIP_PAR')),
           OUTPUT(deno____INN_kp____p, NAMED('DENORMALIZE_KEEP_PAR')),
           OUTPUT(deno____INN_kp_xs_p, NAMED('DENORMALIZE_KEEP_XFMSKIP_PAR')),
           OUTPUT(deno____INN_at____p, NAMED('DENORMALIZE_ATMOST_PAR')),
           OUTPUT(deno____INN_at_xs_p, NAMED('DENORMALIZE_ATMOST_XFMSKIP_PAR')),
           OUTPUT(deno____INN_ls____p, NAMED('DENORMALIZE_LIMITSKIP_PAR')),
           OUTPUT(deno____INN_ls_xs_p, NAMED('DENORMALIZE_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(deno____INN_lo____p, NAMED('DENORMALIZE_LIMITONFAIL_PAR')),
           OUTPUT(deno____INN_lo_xs_p, NAMED('DENORMALIZE_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(deno____LOU_______p, NAMED('DENORMALIZE_LEFT_OUTER_PAR')),
           OUTPUT(deno____LOU____xs_p, NAMED('DENORMALIZE_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(deno____LOU_kp____p, NAMED('DENORMALIZE_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(deno____LOU_kp_xs_p, NAMED('DENORMALIZE_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(deno____LOU_at____p, NAMED('DENORMALIZE_LEFT_OUTER_ATMOST_PAR')),
           OUTPUT(deno____LOU_at_xs_p, NAMED('DENORMALIZE_LEFT_OUTER_ATMOST_XFMSKIP_PAR')),
           OUTPUT(deno____LOU_ls____p, NAMED('DENORMALIZE_LEFT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(deno____LOU_ls_xs_p, NAMED('DENORMALIZE_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(deno____LOU_lo____p, NAMED('DENORMALIZE_LEFT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(deno____LOU_lo_xs_p, NAMED('DENORMALIZE_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(deno____LON_______p, NAMED('DENORMALIZE_LEFT_ONLY_PAR')),
           OUTPUT(deno____LON____xs_p, NAMED('DENORMALIZE_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(deno____LON_at____p, NAMED('DENORMALIZE_LEFT_ONLY_ATMOST_PAR')),
           OUTPUT(deno____LON_at_xs_p, NAMED('DENORMALIZE_LEFT_ONLY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(deno____ROU_______p, NAMED('DENORMALIZE_RIGHT_OUTER_PAR')),
           OUTPUT(deno____ROU____xs_p, NAMED('DENORMALIZE_RIGHT_OUTER_XFMSKIP_PAR')),
           OUTPUT(deno____ROU_ls____p, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(deno____ROU_ls_xs_p, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(deno____ROU_lo____p, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(deno____ROU_lo_xs_p, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(deno____RON_______p, NAMED('DENORMALIZE_RIGHT_ONLY_PAR')),
           OUTPUT(deno____RON____xs_p, NAMED('DENORMALIZE_RIGHT_ONLY_XFMSKIP_PAR')),
           OUTPUT(deno____FOU_______p, NAMED('DENORMALIZE_FULL_OUTER_PAR')),
           OUTPUT(deno____FOU____xs_p, NAMED('DENORMALIZE_FULL_OUTER_XFMSKIP_PAR')),
           OUTPUT(deno____FOU_ls____p, NAMED('DENORMALIZE_FULL_OUTER_LIMITSKIP_PAR')),
           OUTPUT(deno____FOU_ls_xs_p, NAMED('DENORMALIZE_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(deno____FOU_lo____p, NAMED('DENORMALIZE_FULL_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(deno____FOU_lo_xs_p, NAMED('DENORMALIZE_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(deno____FON_______p, NAMED('DENORMALIZE_FULL_ONLY_PAR')),
           OUTPUT(deno____FON____xs_p, NAMED('DENORMALIZE_FULL_ONLY_XFMSKIP_PAR')),
           OUTPUT(deno_l1_INN_______p, NAMED('DENORMALIZE_LOOKUP_PAR')),
           OUTPUT(deno_l1_INN____xs_p, NAMED('DENORMALIZE_LOOKUP_XFMSKIP_PAR')),
           OUTPUT(deno_l1_LOU_______p, NAMED('DENORMALIZE_LOOKUP_LEFT_OUTER_PAR')),
           OUTPUT(deno_l1_LOU____xs_p, NAMED('DENORMALIZE_LOOKUP_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(deno_l1_LON_______p, NAMED('DENORMALIZE_LOOKUP_LEFT_ONLY_PAR')),
           OUTPUT(deno_l1_LON____xs_p, NAMED('DENORMALIZE_LOOKUP_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(deno_lm_INN_______p, NAMED('DENORMALIZE_LOOKUP_MANY_PAR')),
           OUTPUT(deno_lm_INN____xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_XFMSKIP_PAR')),
           OUTPUT(deno_lm_INN_kp____p, NAMED('DENORMALIZE_LOOKUP_MANY_KEEP_PAR')),
           OUTPUT(deno_lm_INN_kp_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_KEEP_XFMSKIP_PAR')),
           OUTPUT(deno_lm_INN_at____p, NAMED('DENORMALIZE_LOOKUP_MANY_ATMOST_PAR')),
           OUTPUT(deno_lm_INN_at_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(deno_lm_INN_ls____p, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITSKIP_PAR')),
           OUTPUT(deno_lm_INN_ls_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(deno_lm_INN_lo____p, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_PAR')),
           OUTPUT(deno_lm_INN_lo_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LOU_______p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_PAR')),
           OUTPUT(deno_lm_LOU____xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LOU_kp____p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(deno_lm_LOU_kp_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LOU_at____p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST_PAR')),
           OUTPUT(deno_lm_LOU_at_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LOU_ls____p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(deno_lm_LOU_ls_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LOU_lo____p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(deno_lm_LOU_lo_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LON_______p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_PAR')),
           OUTPUT(deno_lm_LON____xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(deno_lm_LON_at____p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST_PAR')),
           OUTPUT(deno_lm_LON_at_xs_p, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(deno_al_INN_______p, NAMED('DENORMALIZE_ALL_PAR')),
           OUTPUT(deno_al_INN____xs_p, NAMED('DENORMALIZE_ALL_XFMSKIP_PAR')),
           OUTPUT(deno_al_INN_kp____p, NAMED('DENORMALIZE_ALL_KEEP_PAR')),
           OUTPUT(deno_al_INN_kp_xs_p, NAMED('DENORMALIZE_ALL_KEEP_XFMSKIP_PAR')),
           OUTPUT(deno_al_LOU_______p, NAMED('DENORMALIZE_ALL_LEFT_OUTER_PAR')),
           OUTPUT(deno_al_LOU____xs_p, NAMED('DENORMALIZE_ALL_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(deno_al_LOU_kp____p, NAMED('DENORMALIZE_ALL_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(deno_al_LOU_kp_xs_p, NAMED('DENORMALIZE_ALL_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(deno_al_LON_______p, NAMED('DENORMALIZE_ALL_LEFT_ONLY_PAR')),
           OUTPUT(deno_al_LON____xs_p, NAMED('DENORMALIZE_ALL_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(dngr____INN_______p, NAMED('DENORMALIZEGROUP_PAR')),
           OUTPUT(dngr____INN____xs_p, NAMED('DENORMALIZEGROUP_XFMSKIP_PAR')),
           OUTPUT(dngr____INN_kp____p, NAMED('DENORMALIZEGROUP_KEEP_PAR')),
           OUTPUT(dngr____INN_kp_xs_p, NAMED('DENORMALIZEGROUP_KEEP_XFMSKIP_PAR')),
           OUTPUT(dngr____INN_at____p, NAMED('DENORMALIZEGROUP_ATMOST_PAR')),
           OUTPUT(dngr____INN_at_xs_p, NAMED('DENORMALIZEGROUP_ATMOST_XFMSKIP_PAR')),
           OUTPUT(dngr____INN_ls____p, NAMED('DENORMALIZEGROUP_LIMITSKIP_PAR')),
           OUTPUT(dngr____INN_ls_xs_p, NAMED('DENORMALIZEGROUP_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(dngr____INN_lo____p, NAMED('DENORMALIZEGROUP_LIMITONFAIL_PAR')),
           OUTPUT(dngr____INN_lo_xs_p, NAMED('DENORMALIZEGROUP_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(dngr____LOU_______p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_PAR')),
           OUTPUT(dngr____LOU____xs_p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(dngr____LOU_kp____p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(dngr____LOU_kp_xs_p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(dngr____LOU_at____p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_ATMOST_PAR')),
           OUTPUT(dngr____LOU_at_xs_p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_ATMOST_XFMSKIP_PAR')),
           OUTPUT(dngr____LOU_ls____p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(dngr____LOU_ls_xs_p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(dngr____LOU_lo____p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(dngr____LOU_lo_xs_p, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(dngr____LON_______p, NAMED('DENORMALIZEGROUP_LEFT_ONLY_PAR')),
           OUTPUT(dngr____LON____xs_p, NAMED('DENORMALIZEGROUP_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(dngr____LON_at____p, NAMED('DENORMALIZEGROUP_LEFT_ONLY_ATMOST_PAR')),
           OUTPUT(dngr____LON_at_xs_p, NAMED('DENORMALIZEGROUP_LEFT_ONLY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(dngr____ROU_______p, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_PAR')),
           OUTPUT(dngr____ROU____xs_p, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_XFMSKIP_PAR')),
           OUTPUT(dngr____ROU_ls____p, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(dngr____ROU_ls_xs_p, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(dngr____ROU_lo____p, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(dngr____ROU_lo_xs_p, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(dngr____RON_______p, NAMED('DENORMALIZEGROUP_RIGHT_ONLY_PAR')),
           OUTPUT(dngr____RON____xs_p, NAMED('DENORMALIZEGROUP_RIGHT_ONLY_XFMSKIP_PAR')),
           OUTPUT(dngr____FOU_______p, NAMED('DENORMALIZEGROUP_FULL_OUTER_PAR')),
           OUTPUT(dngr____FOU____xs_p, NAMED('DENORMALIZEGROUP_FULL_OUTER_XFMSKIP_PAR')),
           OUTPUT(dngr____FOU_ls____p, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_PAR')),
           OUTPUT(dngr____FOU_ls_xs_p, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(dngr____FOU_lo____p, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(dngr____FOU_lo_xs_p, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(dngr____FON_______p, NAMED('DENORMALIZEGROUP_FULL_ONLY_PAR')),
           OUTPUT(dngr____FON____xs_p, NAMED('DENORMALIZEGROUP_FULL_ONLY_XFMSKIP_PAR')),
           OUTPUT(dngr_l1_INN_______p, NAMED('DENORMALIZEGROUP_LOOKUP_PAR')),
           OUTPUT(dngr_l1_INN____xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_XFMSKIP_PAR')),
           OUTPUT(dngr_l1_LOU_______p, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_OUTER_PAR')),
           OUTPUT(dngr_l1_LOU____xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(dngr_l1_LON_______p, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_ONLY_PAR')),
           OUTPUT(dngr_l1_LON____xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_INN_______p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_PAR')),
           OUTPUT(dngr_lm_INN____xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_INN_kp____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_KEEP_PAR')),
           OUTPUT(dngr_lm_INN_kp_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_KEEP_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_INN_at____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_ATMOST_PAR')),
           OUTPUT(dngr_lm_INN_at_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_INN_ls____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_PAR')),
           OUTPUT(dngr_lm_INN_ls_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_INN_lo____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_PAR')),
           OUTPUT(dngr_lm_INN_lo_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LOU_______p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_PAR')),
           OUTPUT(dngr_lm_LOU____xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LOU_kp____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(dngr_lm_LOU_kp_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LOU_at____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST_PAR')),
           OUTPUT(dngr_lm_LOU_at_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LOU_ls____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_PAR')),
           OUTPUT(dngr_lm_LOU_ls_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LOU_lo____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_PAR')),
           OUTPUT(dngr_lm_LOU_lo_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LON_______p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_PAR')),
           OUTPUT(dngr_lm_LON____xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_XFMSKIP_PAR')),
           OUTPUT(dngr_lm_LON_at____p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST_PAR')),
           OUTPUT(dngr_lm_LON_at_xs_p, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP_PAR')),
           OUTPUT(dngr_al_INN_______p, NAMED('DENORMALIZEGROUP_ALL_PAR')),
           OUTPUT(dngr_al_INN____xs_p, NAMED('DENORMALIZEGROUP_ALL_XFMSKIP_PAR')),
           OUTPUT(dngr_al_INN_kp____p, NAMED('DENORMALIZEGROUP_ALL_KEEP_PAR')),
           OUTPUT(dngr_al_INN_kp_xs_p, NAMED('DENORMALIZEGROUP_ALL_KEEP_XFMSKIP_PAR')),
           OUTPUT(dngr_al_LOU_______p, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_PAR')),
           OUTPUT(dngr_al_LOU____xs_p, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_XFMSKIP_PAR')),
           OUTPUT(dngr_al_LOU_kp____p, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP_PAR')),
           OUTPUT(dngr_al_LOU_kp_xs_p, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP_XFMSKIP_PAR')),
           OUTPUT(dngr_al_LON_______p, NAMED('DENORMALIZEGROUP_ALL_LEFT_ONLY_PAR')),
           OUTPUT(dngr_al_LON____xs_p, NAMED('DENORMALIZEGROUP_ALL_LEFT_ONLY_XFMSKIP_PAR')));
